// ====================================================================
// Copyright (C) 2012 - Michael Baudin
// This file is released into the public domain
// ====================================================================

function distfun_builderGatewayC()
    gateway_path = get_absolute_file_path("builder_gateway_ccdf.sce");

    libname = "distfuncdfgateway";
    namelist = [
    "distfun_cdfbet"  "sci_distfun_cdfbet"
    "distfun_cdfbin"  "sci_distfun_cdfbin"
    "distfun_cdfchi"  "sci_distfun_cdfchi"
    "distfun_cdfchn"  "sci_distfun_cdfchn"
    "distfun_cdff"    "sci_distfun_cdff"
    "distfun_cdffnc"  "sci_distfun_cdffnc"
    "distfun_cdfgam"  "sci_distfun_cdfgam"
    "distfun_cdfnbn"  "sci_distfun_cdfnbn"
    "distfun_cdfnor"  "sci_distfun_cdfnor"
    "distfun_cdfpoi"  "sci_distfun_cdfpoi"
    "distfun_cdft"    "sci_distfun_cdft"
    "distfun_invcdfpoi" "sci_distfun_invcdfpoi"
    "distfun_invcdfbet" "sci_distfun_invcdfbet"
    "distfun_invcdfbin" "sci_distfun_invcdfbin"
    "distfun_invcdfchi" "sci_distfun_invcdfchi"
    "distfun_invcdfchn" "sci_distfun_invcdfchn"
    "distfun_invcdff" "sci_distfun_invcdff"
    "distfun_invcdfnbn" "sci_distfun_invcdfnbn"
    "distfun_invcdft" "sci_distfun_invcdft"
    "distfun_invcdfgam" "sci_distfun_invcdfgam"
    "distfun_invcdfnor" "sci_distfun_invcdfnor"
    "distfun_invcdffnc" "sci_distfun_invcdffnc"
    ];
    files = [
    "sci_distfun_cdfbet.c"
    "sci_distfun_cdfbin.c"
    "sci_distfun_cdfchi.c"
    "sci_distfun_cdfchn.c"
    "sci_distfun_cdff.c"
    "sci_distfun_cdffnc.c"
    "sci_distfun_cdfgam.c"
    "sci_distfun_cdfnbn.c"
    "sci_distfun_cdfnor.c"
    "sci_distfun_cdfpoi.c"
    "sci_distfun_cdft.c"
    "sci_distfun_invcdfpoi.c"
    "sci_distfun_invcdfbet.c"
    "sci_distfun_invcdfbin.c"
    "sci_distfun_invcdfchi.c"
    "sci_distfun_invcdfchn.c"
    "sci_distfun_invcdff.c"
    "sci_distfun_invcdft.c"
    "sci_distfun_invcdffnc.c"
    "sci_distfun_invcdfgam.c"
    "sci_distfun_invcdfnbn.c"
    "sci_distfun_invcdfnor.c"
    "gw_distfuncdf_support.c"
    ];

    ldflags = ""

    if ( getos() == "Windows" ) then
        include1 = "..\..\src\cdflib";
        include2 = "..\..\src\gwsupport";
        include3 = SCI+"\modules\output_stream\includes";
        cflags = "-DWIN32 "+..
		" -I"""+include1+""""+..
		" -I"""+include2+""""+..
		" -I"""+include3+"""";
    else
        include1 = gateway_path;
        include2 = gateway_path+"../../src/cdflib";
        include3 = gateway_path+"../../src/gwsupport";
        include4 = SCI+"/../../include/scilab/localization";
        cflags = "-I"""+include1+""""+..
		" -I"""+include2+""""+..
		" -I"""+include3+""""+..
		" -I"""+include4+"""";
    end
    // Caution : the order matters !
    libs = [
    "../../src/cdflib/libcdflib"
    "../../src/gwsupport/libgwsupport"
    ];

    tbx_build_gateway(libname, namelist, files, gateway_path, libs, ldflags, cflags);

endfunction
distfun_builderGatewayC();
clear distfun_builderGatewayC;
