// ====================================================================
// Copyright (C) 2012 - Michael Baudin
// This file is released into the public domain
// ====================================================================

function distfun_builderGatewayC()
    gateway_path = get_absolute_file_path("builder_gateway_cgrand.sce");

    libname = "distfungrandgateway";
    namelist = [
    "distfun_grandbet" "sci_distfun_grandbet"
    "distfun_grandf" "sci_distfun_grandf"
    "distfun_grandmul" "sci_distfun_grandmul"
    "distfun_grandgam" "sci_distfun_grandgam"
    "distfun_grandnor" "sci_distfun_grandnor"
    "distfun_grandunf" "sci_distfun_grandunf"
    "distfun_granduin" "sci_distfun_granduin"
    "distfun_grandnbn" "sci_distfun_grandnbn"
    "distfun_grandbin" "sci_distfun_grandbin"
    "distfun_grandmn" "sci_distfun_grandmn"
    "distfun_grandmarkov" "sci_distfun_grandmarkov"
    "distfun_grandnch" "sci_distfun_grandnch"
    "distfun_grandnf" "sci_distfun_grandnf"
    "distfun_grandchi" "sci_distfun_grandchi"
    "distfun_grandexp" "sci_distfun_grandexp"
    "distfun_grandpoi" "sci_distfun_grandpoi"
    "distfun_grandprm" "sci_distfun_grandprm"
    "distfun_grandgeom" "sci_distfun_grandgeom"
    ];
    files = [
    "sci_distfun_grandbet.c"
    "sci_distfun_grandf.c"
    "sci_distfun_grandmul.c"
    "sci_distfun_grandgam.c"
    "sci_distfun_grandnor.c"
    "sci_distfun_grandunf.c"
    "sci_distfun_granduin.c"
    "sci_distfun_grandnbn.c"
    "sci_distfun_grandbin.c"
    "sci_distfun_grandmn.c"
    "sci_distfun_grandmarkov.c"
    "sci_distfun_grandnch.c"
    "sci_distfun_grandnf.c"
    "sci_distfun_grandchi.c"
    "sci_distfun_grandexp.c"
    "sci_distfun_grandpoi.c"
    "sci_distfun_grandprm.c"
    "sci_distfun_grandgeom.c"
    "gw_distfungrand_support.c"
    ];

    ldflags = ""

    if ( getos() == "Windows" ) then
        include1 = "..\..\src\genrand";
        include2 = "..\..\src\unifrng";
        include3 = "..\..\src\gwsupport";
        include4 = SCI+"/modules/output_stream/includes";
        cflags = "-DWIN32"+..
		" -I"""+include1+""""+..
		" -I"""+include2+""""+..
		" -I"""+include3+""""+..
		" -I"""+include4+"""";
    else
        include1 = gateway_path;
        include2 = gateway_path+"../../src/genrand";
        include3 = gateway_path+"../../src/unifrng";
        include4 = gateway_path+"../../src/gwsupport";
        include5 = SCI+"/../../include/scilab/localization";
        cflags = "-I"""+include1+""""+..
		" -I"""+include2+""""+..
		" -I"""+include3+""""+..
		" -I"""+include4+""""+..
		" -I"""+include5+"""";
    end
    // Caution : the order matters !
    libs = [
    "../../src/genrand/libgenrand"
    "../../src/unifrng/libunifrng"
    "../../src/gwsupport/libgwsupport"
    ];

    tbx_build_gateway(libname, namelist, files, gateway_path, libs, ldflags, cflags);

endfunction
distfun_builderGatewayC();
clear distfun_builderGatewayC;
