
/*
* Copyright (C)  2012 - Michael Baudin
* Copyright (C)  2001 - Bruno Pincon
* Copyright (C) ENPC
*
* This file must be used under the terms of the CeCILL.
* This source file is licensed as described in the file COPYING, which
* you should have received as part of this distribution.  The terms
* are also available at
* http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
*
*/

/*------------------------------------------------------------------------
*    Interface for grand
*    jpc@cermics.enpc.fr
*    stuff to deal with several generators added
*         by Bruno Pincon (12/11/2001)
*
--------------------------------------------------------------------------*/
#include <string.h>
#include <math.h>

// From Distfun
#include "gwsupport.h"
#include "genrand.h"
#include "gw_distfungrand.h"
#include "gw_distfungrand_support.h" 

// From Scilab:
#include "Scierror.h"
#include "sciprint.h"
#include "localization.h"
#include "stack-c.h"

/**************************************************
Y=distfun_grandprm(n,vect) 

generate n random permutations of the column vector (m x 1) vect.
***********************************************************************/

int sci_distfun_grandprm(char *fname,unsigned long fname_len)
{
	int rRows,rCols,m1,n1,l1,la,lr;
	int i;
	int nn;
	

	CheckRhs(2,2);
	CheckLhs(1,1);

	GetRhsVar(1,MATRIX_OF_INTEGER_DATATYPE, &rRows, &rCols, &l1);
	if ( rRows*rCols != 1)
	{
		Scierror(999,_("%s: Wrong value for input argument: Number of random simulation expected.\n"),fname);
		return 0;
	}
	nn= *istk(l1);
	GetRhsVar(2,MATRIX_OF_DOUBLE_DATATYPE, &m1, &n1, &la);
	if ( n1 != 1) 
	{ 
		Scierror(999,_("%s: Wrong type for input argument: Column vector expected.\n"),fname);
		return 0;
	}
	CreateVar(Rhs+1,MATRIX_OF_DOUBLE_DATATYPE,&m1,&nn,&lr);
	for ( i=0 ; i < nn ; i++)
	{
		int j ;
		for (j=0; j < m1 ; j++ ) {
			*stk(lr+(m1)*i+j)= *stk(la+j);
		}
		genprm(stk(lr+(m1)*i),&m1);
	}
	LhsVar(1) = Rhs+1;

	return 0;
}
