// ====================================================================
// Copyright (C) 2012 - Michael Baudin
// This file is released into the public domain
// ====================================================================

function distfun_builderGatewayC()
    gateway_path = get_absolute_file_path("builder_gateway_driver.sce");

    libname = "distfundrivergateway";
    namelist = [
    "distfun_startup"   "sci_distfun_startup"
    ];
    files = [
    "sci_distfun_startup.c"
    ];

    ldflags = ""

    if ( getos() == "Windows" ) then
        include1 = "..\..\src\genrand";
        include2 = "..\..\src\unifrng";
        include3 = "..\..\src\gwsupport";
        include4 = "..\..\src\cdflib";
        include5 = SCI+"/modules/output_stream/includes";
        cflags = "-DWIN32"+..
		" -I"""+include1+""""+..
		" -I"""+include2+""""+..
		" -I"""+include3+""""+..
		" -I"""+include4+""""+..
		" -I"""+include5+"""";
    else
        include1 = gateway_path;
        include2 = gateway_path+"../../src/genrand";
        include3 = gateway_path+"../../src/unifrng";
        include4 = gateway_path+"../../src/gwsupport";
        include5 = gateway_path+"../../src/cdflib";
        include6 = SCI+"/../../include/scilab/localization";
        cflags = "-I"""+include1+""""+..
		" -I"""+include2+""""+..
		" -I"""+include3+""""+..
		" -I"""+include4+""""+..
		" -I"""+include5+""""+..
		" -I"""+include6+"""";
    end
    // Caution : the order matters !
    libs = [
    "../../src/gwsupport/libgwsupport"
    "../../src/genrand/libgenrand"
    "../../src/unifrng/libunifrng"
    "../../src/cdflib/libcdflib"
    ];

    tbx_build_gateway(libname, namelist, files, gateway_path, libs, ldflags, cflags);

endfunction
distfun_builderGatewayC();
clear distfun_builderGatewayC;

