/* bfrac.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "cdflib.h"
#include <math.h>

double bfrac_(double *a, double *b, double *x, double *y, 
	double *lambda, double *eps)
{
	/* System generated locals */
	double ret_val, d__1;

	/* Local variables */
	static double c__, e, n, p, r__, s, t, w, c0, c1, r0, an, bn, yp1, 
		anp1, bnp1, beta, alpha;

	/* ----------------------------------------------------------------------- */
	/*     CONTINUED FRACTION EXPANSION FOR IX(A,B) WHEN A,B .GT. 1. */
	/*     IT IS ASSUMED THAT  LAMBDA = (A + B)*Y - B. */
	/* ----------------------------------------------------------------------- */
	/*     .. Scalar Arguments .. */
	/*     .. */
	/*     .. Local Scalars .. */
	/*     .. */

	/*     .. */
	/*     .. Intrinsic Functions .. */
	/*     .. */
	/*     .. Executable Statements .. */
	/* -------------------- */
	ret_val = brcomp_(a, b, x, y);
	if (ret_val == 0.) {
		return ret_val;
	}

	c__ = *lambda + 1.;
	c0 = *b / *a;
	c1 = 1. / *a + 1.;
	yp1 = *y + 1.;

	n = 0.;
	p = 1.;
	s = *a + 1.;
	an = 0.;
	bn = 1.;
	anp1 = 1.;
	bnp1 = c__ / c1;
	r__ = c1 / c__;

	/*        CONTINUED FRACTION CALCULATION */

L10:
	n += 1.;
	t = n / *a;
	w = n * (*b - n) * *x;
	e = *a / s;
	alpha = p * (p + c0) * e * e * (w * *x);
	e = (t + 1.) / (c1 + t + t);
	beta = n + w / s + e * (c__ + n * yp1);
	p = t + 1.;
	s += 2.;

	/*        UPDATE AN, BN, ANP1, AND BNP1 */

	t = alpha * an + beta * anp1;
	an = anp1;
	anp1 = t;
	t = alpha * bn + beta * bnp1;
	bn = bnp1;
	bnp1 = t;

	r0 = r__;
	r__ = anp1 / bnp1;
	if ((d__1 = r__ - r0, fabs(d__1)) <= *eps * r__) {
		goto L20;
	}

	/*        RESCALE AN, BN, ANP1, AND BNP1 */

	an /= bnp1;
	bn /= bnp1;
	anp1 = r__;
	bnp1 = 1.;
	goto L10;

	/*                 TERMINATION */

L20:
	ret_val *= r__;
	return ret_val;
} /* bfrac_ */

