
/*
 * Copyright (C) 2012 - Michael Baudin
 *
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 */

#include <string.h>
#include <stdio.h>

#include "cdflib.h"

// Parameters used in the cdf*.c functions

double cdflib_rtol(void)
{
	double ret_val;
	double eps;
	eps = dlamch_("p", (long int)1);
	ret_val = 2*eps;
	return ret_val;

}

double cdflib_zero(void)
{
	double ret_val;
	ret_val = dlamch_("u", (long int)1);
	return ret_val;
}

double cdflib_inf(void)
{
	double ret_val;
	ret_val = dlamch_("o", (long int)1);
	return ret_val;
}

// Initialize the message function to NULL.
void (* cdflib_messagefunction)(char * message) = NULL;

// Prints a message.
void cdflib_messageprint ( char * message ) 
{
	if (cdflib_messagefunction==NULL) {
		printf("%s\n",message);
	}
	else 
	{
		cdflib_messagefunction(message);
	}
}

// Configures the message function
void cdflib_messageSetFunction ( void (* f)(char * message) ) 
{
	cdflib_messagefunction = f;
}

