/* cumf.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
  */

#include "cdflib.h"

/* Subroutine */ int cumf_(double *f, double *dfn, double *dfd, 
	double *cum, double *ccum)
{
	/* System generated locals */
	double d__1, d__2;

	/* Local variables */
	static double xx, yy;
	static int ierr;
	static double prod, dsum;

	/* ********************************************************************** */

	/*     SUBROUTINE CUMF(F,DFN,DFD,CUM,CCUM) */
	/*                    CUMulative F distribution */


	/*                              Function */


	/*     Computes  the  integral from  0  to  F of  the f-density  with DFN */
	/*     and DFD degrees of freedom. */


	/*                              Arguments */


	/*     F --> Upper limit of integration of the f-density. */
	/*                                                  F is DOUBLE PRECISION */

	/*     DFN --> Degrees of freedom of the numerator sum of squares. */
	/*                                                  DFN is DOUBLE PRECISI */

	/*     DFD --> Degrees of freedom of the denominator sum of squares. */
	/*                                                  DFD is DOUBLE PRECISI */

	/*     CUM <-- Cumulative f distribution. */
	/*                                                  CUM is DOUBLE PRECISI */

	/*     CCUM <-- Compliment of Cumulative f distribution. */
	/*                                                  CCUM is DOUBLE PRECIS */


	/*                              Method */


	/*     Formula  26.5.28 of  Abramowitz and   Stegun   is  used to  reduce */
	/*     the cumulative F to a cumulative beta distribution. */


	/*                              Note */


	/*     If F is less than or equal to 0, 0 is returned. */

	/* ********************************************************************** */
	/*     .. Scalar Arguments .. */
	/*     .. */
	/*     .. Local Scalars .. */
	/*     .. */
	/*     .. Parameters .. */
	/*     .. */

	/*     .. */
	/*     .. Executable Statements .. */
	if (! (*f <= 0.)) {
		goto L10;
	}
	*cum = 0.;
	*ccum = 1.;
	return 0;
L10:
	prod = *dfn * *f;

	/*     XX is such that the incomplete beta with parameters */
	/*     DFD/2 and DFN/2 evaluated at XX is 1 - CUM or CCUM */

	/*     YY is 1 - XX */

	/*     Calculate the smaller of XX and YY accurately */

	dsum = *dfd + prod;
	xx = *dfd / dsum;
	if (xx > .5) {
		yy = prod / dsum;
		xx = 1. - yy;
	} else {
		yy = 1. - xx;
	}
	d__1 = *dfd * .5;
	d__2 = *dfn * .5;
	bratio_(&d__1, &d__2, &xx, &yy, ccum, cum, &ierr);
	return 0;
} /* cumf_ */

