/* cumgam.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
  */

#include "cdflib.h"

/* Table of constant values */

static int c__0 = 0;

/* Subroutine */ int cumgam_(double *x, double *a, double *cum, 
	double *ccum)
{

	/* ********************************************************************** */

	/*     SUBROUTINE CUMGAM(X,A,CUM,CCUM) */
	/*           Double precision cUMulative incomplete GAMma distribution */


	/*                              Function */


	/*     Computes   the  cumulative        of    the     incomplete   gamma */
	/*     distribution, i.e., the integral from 0 to X of */
	/*          (1/GAM(A))*EXP(-T)*T**(A-1) DT */
	/*     where GAM(A) is the complete gamma function of A, i.e., */
	/*          GAM(A) = integral from 0 to infinity of */
	/*                    EXP(-T)*T**(A-1) DT */


	/*                              Arguments */


	/*     X --> The upper limit of integration of the incomplete gamma. */
	/*                                                X is DOUBLE PRECISION */

	/*     A --> The shape parameter of the incomplete gamma. */
	/*                                                A is DOUBLE PRECISION */

	/*     CUM <-- Cumulative incomplete gamma distribution. */
	/*                                        CUM is DOUBLE PRECISION */

	/*     CCUM <-- Compliment of Cumulative incomplete gamma distribution. */
	/*                                                CCUM is DOUBLE PRECISIO */


	/*                              Method */


	/*     Calls the routine GRATIO. */

	/* ********************************************************************** */

	/*     .. */
	/*     .. Scalar Arguments .. */
	/*     .. */

	/*     .. */
	/*     .. Executable Statements .. */
	if (! (*x <= 0.)) {
		goto L10;
	}
	*cum = 0.;
	*ccum = 1.;
	return 0;
L10:
	gratio_(a, x, cum, ccum, &c__0);
	/*     Call gratio routine */
	return 0;
} /* cumgam_ */

