/* stvaln.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "cdflib.h"
#include <math.h>

/* Table of constant values */

static int c__5 = 5;

double stvaln_(double *p)
{
	/* Initialized data */

	static double xnum[5] = { -.322232431088,-1.,-.342242088547,
		-.0204231210245,-4.53642210148e-5 };
	static double xden[5] = { .099348462606,.588581570495,.531103462366,
		.10353775285,.0038560700634 };

	/* System generated locals */
	double ret_val;

	/* Local variables */
	static double y, z__, sign;


	/* ********************************************************************** */

	/*     DOUBLE PRECISION FUNCTION STVALN(P) */
	/*                    STarting VALue for Neton-Raphon */
	/*                calculation of Normal distribution Inverse */


	/*                              Function */


	/*     Returns X  such that CUMNOR(X)  =   P,  i.e., the  integral from - */
	/*     infinity to X of (1/SQRT(2*PI)) EXP(-U*U/2) dU is P */


	/*                              Arguments */


	/*     P --> The probability whose normal deviate is sought. */
	/*                    P is DOUBLE PRECISION */


	/*                              Method */


	/*     The  rational   function   on  page 95    of Kennedy  and  Gentle, */
	/*     Statistical Computing, Marcel Dekker, NY , 1980. */

	/* ********************************************************************** */

	/*     .. Scalar Arguments .. */
	/*     .. */
	/*     .. Local Scalars .. */
	/*     .. */
	/*     .. Local Arrays .. */
	/*     .. */

	/*     .. */
	/*     .. Intrinsic Functions .. */
	/*     .. */
	/*     .. Data statements .. */
	/*     .. */
	/*     .. Executable Statements .. */
	if (! (*p <= .5)) {
		goto L10;
	}
	sign = -1.;
	z__ = *p;
	goto L20;
L10:
	sign = 1.;
	z__ = 1. - *p;
L20:
	y = sqrt(log(z__) * -2.);
	ret_val = y + devlpl_(xnum, &c__5, &y) / devlpl_(xden, &c__5, &y);
	ret_val = sign * ret_val;
	return ret_val;
} /* stvaln_ */

