/* genf.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "genrand.h"

double genf(double *dfn, double *dfd)
{
	/* System generated locals */
	double ret_val, d__1;

	/* Local variables */
	static int io;
	static float wte;
	static double xden, xnum;

	/* ********************************************************************** */

	/*     DOUBLE PRECISION FUNCTION GENF( DFN, DFD ) */
	/*                GENerate random deviate from the F distribution */


	/*                              Function */


	/*     Generates a random deviate from the F (variance ratio) */
	/*     distribution with DFN degrees of freedom in the numerator */
	/*     and DFD degrees of freedom in the denominator. */


	/*                              Arguments */


	/*     DFN --> Numerator degrees of freedom */
	/*             (Must be positive) */
	/*                              DOUBLE PRECISION DFN */
	/*      DFD --> Denominator degrees of freedom */
	/*             (Must be positive) */
	/*                              DOUBLE PRECISION DFD */


	/*                              Method */


	/*     Directly generates ratio of chisquare variates */

	/* ********************************************************************** */
	/*      include 'stack.h' */
	/*     .. Scalar Arguments .. */
	/*     .. */
	/*     .. Local Scalars .. */
	/*     .. */
	/*     JJV changed this code to call sgamma directly */

	/*      DOUBLE PRECISION genchi */
	/*      EXTERNAL genchi */
	/*     .. */
	/*     .. Executable Statements .. */
	/* L10: */
	d__1 = *dfn / 2.f;
	xnum = sgamma(&d__1) * 2.f / *dfn;
	/*      GENF = ( GENCHI( DFN ) / DFN ) / ( GENCHI( DFD ) / DFD ) */
	d__1 = *dfd / 2.f;
	xden = sgamma(&d__1) * 2.f / *dfd;
	/*     JJV changed constant so that it will not underflow at compile time */
	/*     JJV while not slowing generator by using double precision or logs. */
	/*      IF (.NOT. (xden.LE. (1.0E-38*xnum))) GO TO 20 */
	if (! (xden <= xnum * 1e-37f)) {
		goto L20;
	}
	genrand_messageprint("F Random Number: generated numbers would cause overflow");
	/*      WRITE (*,*) ' Numerator ',xnum,' Denominator ',xden */
	/*     JJV next 2 lines changed to maintain truncation of large deviates. */
	/*      WRITE (*,*) ' GENF returning 1.0E38' */
	/*      genf = 1.0E38 */
	genrand_messageprint("GENF returning 1.0E37");
	ret_val = 1e37f;
	goto L30;
L20:
	ret_val = xnum / xden;
L30:
	return ret_val;
} /* genf_ */

