/* genmul.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "genrand.h"

/* Subroutine */ int genmul(int *n, double *p, int *ncat, 
	int *ix)
{
	/* System generated locals */
	int i__1;

	/* Local variables */
	static int i__;
	static double sum;
	static int icat;
	static double prob;
	static int ntot;

	/* ********************************************************************** */

	/*            SUBROUTINE GENMUL( N, P, NCAT, IX ) */
	/*     GENerate an observation from the MULtinomial distribution */


	/*                              Arguments */


	/*     N --> Number of events that will be classified into one of */
	/*           the categories 1..NCAT */
	/*                         INTEGER N */

	/*     P --> Vector of probabilities.  P(i) is the probability that */
	/*           an event will be classified into category i.  Thus, P(i) */
	/*           must be [0,1]. Only the first NCAT-1 P(i) must be defined */
	/*           since P(NCAT) is 1.0 minus the sum of the first */
	/*           NCAT-1 P(i). */
	/*                         DOUBLE PRECISION P(NCAT-1) */

	/*     NCAT --> Number of categories.  Length of P and IX. */
	/*                         INTEGER NCAT */

	/*     IX <-- Observation from multinomial distribution.  All IX(i) */
	/*            will be nonnegative and their sum will be N. */
	/*                         INTEGER IX(NCAT) */


	/*                              Method */


	/*     Algorithm from page 559 of */

	/*     Devroye, Luc */

	/*     Non-Uniform Random Variate Generation.  Springer-Verlag, */
	/*     New York, 1986. */

	/* ********************************************************************** */
	/*     .. Scalar Arguments .. */
	/*     .. */
	/*     .. Array Arguments .. */
	/*     .. */
	/*     .. Local Scalars .. */
	/*     .. */

	/*     .. */
	/*     .. Intrinsic Functions .. */
	/*     .. */
	/*     .. Executable Statements .. */
	/*     Check Arguments */
	/*     see Rand.c */
	/*     Initialize variables */
	/* Parameter adjustments */
	--ix;
	--p;

	/* Function Body */
	ntot = *n;
	sum = 1.f;
	i__1 = *ncat;
	for (i__ = 1; i__ <= i__1; ++i__) {
		ix[i__] = 0;
		/* L20: */
	}
	/*     Generate the observation */
	i__1 = *ncat - 1;
	for (icat = 1; icat <= i__1; ++icat) {
		prob = p[icat] / sum;
		ix[icat] = ignbin(&ntot, &prob);
		ntot -= ix[icat];
		if (ntot <= 0) {
			return 0;
		}
		sum -= p[icat];
		/* L30: */
	}
	ix[*ncat] = ntot;
	/*     Finished */
	return 0;
} /* genmul_ */

