/* gennf.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "genrand.h"
#include <math.h>

double gennf(double *dfn, double *dfd, double *xnonc)
{
	/* System generated locals */
	double ret_val, d__1, d__2;

	/* Local variables */
	static int io;
	static float wte;
	static double xden, xnum;

	/* ********************************************************************** */

	/*     DOUBLE PRECISION FUNCTION GENNF( DFN, DFD, XNONC ) */
	/*           GENerate random deviate from the Noncentral F distribution */


	/*                              Function */


	/*     Generates a random deviate from the  noncentral F (variance ratio) */
	/*     distribution with DFN degrees of freedom in the numerator, and DFD */
	/*     degrees of freedom in the denominator, and noncentrality parameter */
	/*     XNONC. */


	/*                              Arguments */


	/*     DFN --> Numerator degrees of freedom */
	/*             (Must be >= 1.0) */
	/*                              DOUBLE PRECISION DFN */
	/*      DFD --> Denominator degrees of freedom */
	/*             (Must be positive) */
	/*                              DOUBLE PRECISION DFD */

	/*     XNONC --> Noncentrality parameter */
	/*               (Must be nonnegative) */
	/*                              DOUBLE PRECISION XNONC */


	/*                              Method */


	/*     Directly generates ratio of noncentral numerator chisquare variate */
	/*     to central denominator chisquare variate. */

	/* ********************************************************************** */
	/*      include 'stack.h' */
	/*     .. Scalar Arguments .. */
	/*     .. */
	/*     .. Local Scalars .. */
	/*     .. */

	/*     JJV changed the code to call SGAMMA and SNORM directly */
	/*      DOUBLE PRECISION genchi,gennch */
	/*      EXTERNAL genchi,gennch */
	/*     .. */
	/*     .. Executable Statements .. */
	/*     JJV changed the argument checker to allow DFN = 1.0 */
	/*     JJV in the same way as GENNCH was changed. */
	/*      GENNF = ( GENNCH( DFN, XNONC ) / DFN ) / ( GENCHI( DFD ) / DFD ) */
	/*     JJV changed this to call SGAMMA and SNORM directly */
	/*     xnum = gennch(dfn,xnonc)/dfn */
	/* L10: */
	if (*dfn >= 1.000001f) {
		goto L20;
	}
	/*     JJV case dfn = 1.0 - here I am treating dfn as exactly 1.0 */
	/* Computing 2nd power */
	d__1 = snorm() + sqrt(*xnonc);
	xnum = d__1 * d__1;
	goto L30;
	/*     JJV case dfn > 1.0 */
L20:
	d__1 = (*dfn - 1.f) / 2.f;
	/* Computing 2nd power */
	d__2 = snorm() + sqrt(*xnonc);
	xnum = (sgamma(&d__1) * 2.f + d__2 * d__2) / *dfn;
	/*     xden = genchi(dfd)/dfd */
L30:
	d__1 = *dfd / 2.f;
	xden = sgamma(&d__1) * 2.f / *dfd;
	/*     JJV changed constant so that it will not underflow at compile time */
	/*     JJV while not slowing generator by using double precision or logs. */
	/*      IF (.NOT. (xden.LE. (1.0E-38*xnum))) GO TO 40 */
	if (! (xden <= xnum * 1e-37f)) {
		goto L40;
	}
	genrand_messageprint("Noncentral F Random Number: Generated numbers would cause overflow");
	/*     JJV next 2 lines changed to maintain truncation of large deviates. */
	/*      WRITE (*,*) ' GENNF returning 1.0E38' */
	/*      gennf = 1.0E38 */
	genrand_messageprint("Noncentral F Random Number: Returning 1.0E37");
	ret_val = 1e37f;
	goto L50;
L40:
	ret_val = xnum / xden;
L50:
	return ret_val;
} /* gennf_ */

