/* gennor.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "genrand.h"

double gennor(double *av, double *sd)
{
	/* System generated locals */
	double ret_val;

	/* Local variables */

	/* ********************************************************************** */

	/*     DOUBLE PRECISION FUNCTION GENNOR( AV, SD ) */

	/*         GENerate random deviate from a NORmal distribution */


	/*                              Function */


	/*     Generates a single random deviate from a normal distribution */
	/*     with mean, AV, and standard deviation, SD. */


	/*                              Arguments */


	/*     AV --> Mean of the normal distribution. */
	/*                              DOUBLE PRECISION AV */

	/*     SD --> Standard deviation of the normal distribution. */
	/*                              DOUBLE PRECISION SD */
	/*     JJV                      (SD >= 0) */

	/*     GENNOR <-- Generated normal deviate. */
	/*                              DOUBLE PRECISION GENNOR */


	/*                              Method */


	/*     Renames SNORM from TOMS as slightly modified by BWB to use RANF */
	/*     instead of SUNIF. */

	/*     For details see: */
	/*               Ahrens, J.H. and Dieter, U. */
	/*               Extensions of Forsythe's Method for Random */
	/*               Sampling from the Normal Distribution. */
	/*               Math. Comput., 27,124 (Oct. 1973), 927 - 937. */


	/* ********************************************************************** */
	/*     .. Scalar Arguments .. */
	/*     .. */

	/*     .. */
	/*     .. Executable Statements .. */
	/*     JJV added check to ensure SD >= 0.0 */
	/* L10: */
	ret_val = *sd * snorm() + *av;
	return ret_val;
} /* gennor_ */

