/* ignnbn.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "genrand.h"

int ignnbn(int *n, double *p)
{
	/* System generated locals */
	int ret_val;

	/* Local variables */
	static double a, r__, y;

	/* ********************************************************************** */

	/*     int FUNCTION IGNNBN( N, P ) */

	/*                GENerate Negative BiNomial random deviate */


	/*                              Function */


	/*     Generates a single random deviate from a negative binomial */
	/*     distribution. */


	/*                              Arguments */


	/*     N  --> Required number of events. */
	/*                              int N */
	/*     JJV                      (N > 0) */

	/*     P  --> The probability of an event during a Bernoulli trial. */
	/*                              DOUBLE PRECISION P */
	/*     JJV                      (0.0 < P < 1.0) */



	/*                              Method */


	/*     Algorithm from page 480 of */

	/*     Devroye, Luc */

	/*     Non-Uniform Random Variate Generation.  Springer-Verlag, */
	/*     New York, 1986. */

	/* ********************************************************************** */
	/*     .. */
	/*     .. Scalar Arguments .. */
	/*     .. */
	/*     .. Local Scalars .. */
	/*     .. */

	/*     JJV changed to call SGAMMA directly */
	/*     DOUBLE PRECISION gengam */
	/*      EXTERNAL gengam,ignpoi */
	/*     .. */
	/*     .. Intrinsic Functions .. */
	/*     .. */
	/*     .. Executable Statements .. */
	/*     Check Arguments */
	/*     JJV changed argumnet checker to abort if N <= 0 */
	/*     See Rand,c */
	/*     Generate Y, a random gamma (n,(1-p)/p) variable */
	/*     JJV Note: the above parametrization is consistent with Devroye, */
	/*     JJV       but gamma (p/(1-p),n) is the equivalent in our code */
	/* L10: */
	r__ = (double) (*n);
	a = *p / (1.f - *p);
	/*      y = gengam(a,r) */
	y = sgamma(&r__) / a;
	/*     Generate a random Poisson(y) variable */
	ret_val = ignpoi(&y);
	return ret_val;
} /* ignnbn_ */

