/* logp1.f -- translated by f2c (version 20100827).
with manual tuning by Michael Baudin (2012)
*/

#include "genrand.h"

/* Copyright (C) Bruno Pincon */

/* This file must be used under the terms of the CeCILL. */
/* This source file is licensed as described in the file COPYING, which */
/* you should have received as part of this distribution.  The terms */
/* are also available at */
/* http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt */


// Computes log(1+x) accurately for small x

#include "genrand.h"
#include <math.h>

double logp1(double *x)
{
	/* System generated locals */
	double ret_val;

	/* Local variables */
	static double g;

	if (*x < -1.) {
		/*        got NaN */
		ret_val = (*x - *x) / (*x - *x);
	} else if (-.33333333333333331 <= *x && *x <= .5) {
		/*        use the function log((1+g)/(1-g)) with g = x/(x + 2) */
		g = *x / (*x + 2.);
		ret_val = lnp1m1(&g);
	} else {
		/*        use the standard formula */
		ret_val = log(*x + 1.);
	}
	return ret_val;
} /* logp1_ */

