// Copyright (C) 2012 - Prateek Papriwal
//
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

//
// Check empty matrix

p = distfun_binocdf([],[],[]);
assert_checkequal(p,[]);

// Check with X scalar, N scalar, Pr scalar
//

computed = distfun_binocdf(100,162,0.5);
expected = 0.9989567;
assert_checkalmostequal(computed,expected,10 .^-07);

// Check with expanded X

computed = distfun_binocdf([5 15],100,0.05);
expected = [0.6159991 0.9999629];
assert_checkalmostequal(computed,expected,10 .^-07);

// Check with expanded N

computed = distfun_binocdf(5,[50 100],0.05);
expected = [0.9622238 0.6159991];
assert_checkalmostequal(computed,expected,10 .^-07);

// Check with expanded Pr

computed = distfun_binocdf(5,50,[0.05 0.1]);
expected = [0.9622238 0.6161230];
assert_checkalmostequal(computed,expected,10 .^-07);

// Check with two arguments expanded 

computed = distfun_binocdf([5 10],[50 100],0.05);
expected = [0.9622238 0.9885276];
assert_checkalmostequal(computed,expected,10 .^-07);

computed = distfun_binocdf([5 10],100,[0.05 0.1]);
expected = [0.6159991 0.5831555];
assert_checkalmostequal(computed,expected,10 .^-07);

computed = distfun_binocdf(5,[50 100],[0.05 0.1]);
expected = [0.9622238 0.0575769];
assert_checkalmostequal(computed,expected,10 .^-07);

// Check with all the arguments expanded

computed = distfun_binocdf([5 10],[50 100],[0.05 0.1]);
expected = [0.9622238 0.5831555];
assert_checkalmostequal(computed,expected,10 .^-07);

//
//Check vectorisation
//

N = 100;
Pr = 0.22;
X = linspace(1,100,10);
p = distfun_binocdf(X,N,Pr);

p2 = [];

for i = 1:10
    p2(1,i) = distfun_binocdf(X(i),N,Pr);
end

assert_checkequal(p,p2);

//check upper tail

p = distfun_binocdf(3,10,0.1);
lt_expected = 0.9872048;
assert_checkalmostequal(p,lt_expected,10.^-7);

q = distfun_binocdf(3,10,0.1,%f);
ut_expected = 0.0127952;
assert_checkalmostequal(q,ut_expected,10.^-6);
