// =============================================================================
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) ????-2008 - INRIA
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// =============================================================================

// =============================================================================
// Tests for beta distribution
// =============================================================================

prec = 1.e-5;

A  = 2;
B  = 3;
bn = 1;

function y = Beta(x)
  y=bn*(x^(A-1) * (1-x)^(B-1))
endfunction

bn = intg(0,1,Beta);
bn = 1/bn;

if norm(intg(0,1,Beta)-1)> prec then pause,end

x  = 0:0.1:1;
y  = 1-x;
p1 = [];

for k=x
	p1=[p1,intg(0,k,Beta)];
end

A = 2*ones(x);
B = 3*ones(x);

[p,q]=distfun_cdfbet(x,y,A,B);

if norm(p-p1) > prec then pause,end
