// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2009 - 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

//
// Tests from Yalta
// Check Binomial distribution with parameters (k, n = 1030, p = 0.5)
//

path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","cdf","binomialcdf.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
Xk = evstr(table(:,1));
expected = evstr(table(:,2));

nt = size(table,"r");
precision = 1.e-5;
for k = 1 : nt
  Pr = 0.5;
  Ompr = 1 - Pr;
  Xn = 1030;
  [computed,Q]=distfun_cdfbin(Xk(k),Xn,Pr,Ompr);
  assert_checkalmostequal ( computed , expected(k) , precision );
  if ( %t ) then
    dP = assert_computedigits ( computed , expected(k) );
    mprintf("Test #%3d/%3d: Digits P=%.1f\n",k,nt,dP);
  end
end

