// Copyright (C) 2009 - 2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->


// 
// Table from Yalta
//
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","normal","normal.yalta.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);

precision = 1.e-4 * ones(14,1);
// The precision is lower for the largest values of X:
// This is because X has only 4 significant digits on input.
precision(10:14)=1.e-3;
nt = size(table,"r");
for k = 1 : nt
  p = table(k,1);
  x = table(k,2);
  q = 1 - p;
  Mean = 0;
  sigma = 1;
  [p1,q1] = distfun_cdfnor ( x , Mean , sigma );
  assert_checkalmostequal ( p1 , p , precision(k) );
  assert_checkalmostequal ( q1 , q , precision(k) );
  if ( %f ) then
    dP = assert_computedigits ( p1 , p );
    dQ = assert_computedigits ( q1 , q );
    mprintf("Test #%3d/%3d: Digits p1= %.1f, q1=%.1f\n",k,nt,dP,dQ);
  end
end

//
// Values from R-2.8.1
// table = [x mu sigma PDF-P CDF-P CDF-Q]
//
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","normal","normal.R.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);

precision = 1.e-12;
precinv = 1.e-8;

nt = size(table,"r");
for k = 1 : nt
  x = table(k,1);
  mu = table(k,2);
  sigma = table(k,3);
  p = table(k,5);
  q = table(k,6);
  [ p1 , q1 ] = distfun_cdfnor(x,mu,sigma);
  assert_checkalmostequal ( p1 , p , precision );
  assert_checkalmostequal ( q1 , q , precision );
  if ( %f ) then
    dP = assert_computedigits ( p1 , p );
    dQ = assert_computedigits ( q1 , q );
    mprintf("Test #%3d/%3d: Digits p1= %.1f, q1=%.1f\n",k,nt,dP,dQ);
  end
end


