// Copyright (C) 2009-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->
// <-- ENGLISH IMPOSED -->

//
// Tests from Yalta
// table = [x lambda p precision]
//
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","cdf","poisson.yalta.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);

precision = 1.e-5;

nt = size(table,"r");
for k = 1 : nt
  Xk = table(k,1);
  lambda = table(k,2);
  expected = table(k,3);
  [computed,Q]=distfun_cdfpoi(Xk,lambda);
  assert_checkalmostequal ( computed , expected , precision );
  if ( %f ) then
    dp = assert_computedigits ( expected , computed );
    mprintf("Test #%3d/%3d: Digits P= %.1f\n",k,nt,dp);
  end
end

//
// Values from R-2.8.1
// table = [x lambda PDF-P CDF-P CDF-Q]
// Some tests do not pass with Scilab.
//
path=distfun_getpath();
dataset = fullfile(path,"tests","unit_tests","cdf","poisson.R.dataset.csv");
table = assert_csvread ( dataset , "," , [] , "/#(.*)/" );
table = evstr(table);


precision = 1.e-12;
precinv = 1.e-8;
nt = size(table,"r");
for k = 1 : nt
  x = table(k,1);
  lambda = table(k,2);
  p = table(k,4);
  q = table(k,5);
  [ p1 , q1 ] = distfun_cdfpoi(x,lambda);
  assert_checkalmostequal ( p1 , p , precision );
  assert_checkalmostequal ( q1 , q , precision );
  if ( %f ) then
    dP = assert_computedigits ( p1 , p );
    dQ = assert_computedigits ( q1 , q );
    mprintf("Test #%3d/%3d: Digits p1= %.1f, q1=%.1f\n",k,nt,dP,dQ);
  end
end


