// =============================================================================
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2008 - INRIA - Sabine Gaüzere
// Copyright (C) 2010-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// =============================================================================
// <-- JVM NOT MANDATORY -->

path = distfun_getpath (  );
exec(fullfile(path,"tests","unit_tests","testingutilities.sce"));


rtol = 1.e-2;
atol = 1.e-2;

// The number of classes in the histogram
// NC must be even.
NC = 2*12;
N=10000;

// Set the seed to always get the same random numbers
distfun_seedset(0);

//
// distfun_grandbet
//

function p = mycdfbet (X,A,B)
  p = distfun_cdfbet(X,1-X,A*ones(X),B*ones(X));
endfunction

A=3;
B=10;
R = distfun_grandbet(400,800,A,B);
checkMeanVariance ( 400 , 800 , R , A/(A+B) , (A*B)/((A+B)^2*(A+B+1)) , rtol );
//
for A = linspace(1,20,4)
  for B = linspace(1,20,4)
    R = distfun_grandbet(1,N,A,B);
    checkLaw2arg ( R , mycdfbet , N , NC , A , B , rtol , atol );
  end
end

// Check expansion of arguments
a = matrix(1:6,2,3);
b = a+1;
checkExpansion2args ( 2 , 3 , distfun_grandbet , a, b);
