// =============================================================================
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2008 - INRIA - Sabine Gaüzere
// Copyright (C) 2010-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// =============================================================================
// <-- JVM NOT MANDATORY -->

path = distfun_getpath (  );
exec(fullfile(path,"tests","unit_tests","testingutilities.sce"));


rtol = 1.e-2;
atol = 1.e-2;

// The number of classes in the histogram
// NC must be even.
NC = 2*12;
N=10000;

// Set the seed to always get the same random numbers
distfun_seedset(0);

//
// distfun_grandchi
//

function p = mycdfchi (X,A)
  p = distfun_cdfchi(X,A*ones(X));
endfunction

A = 7;
R = distfun_grandchi(400,800,A);
checkMeanVariance ( 400 , 800 , R , A , 2*A , rtol );

// Increase the tolerance for this test.
for A = floor(linspace(1,20,10))
    R = distfun_grandchi(1,N,A);
    checkLaw1arg ( R , mycdfchi , N , NC , A , 2*rtol , atol );
end

// Check expansion of arguments
a = matrix(1:6,2,3);
checkExpansion1arg ( 2 , 3 , distfun_grandchi , a);
