// =============================================================================
// Copyright (C) 2012 - Michael Baudin
// Copyright (C) 2008 - INRIA - Sabine Gaüzere
// Copyright (C) 2010-2011 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
// =============================================================================
// <-- JVM NOT MANDATORY -->

path = distfun_getpath (  );
exec(fullfile(path,"tests","unit_tests","testingutilities.sce"));


rtol = 1.e-2;
atol = 1.e-2;

// The number of classes in the histogram
// NC must be even.
NC = 2*12;
N=10000;

// Set the seed to always get the same random numbers
distfun_seedset(0);

//
// distfun_grandgeom
// http://en.wikipedia.org/wiki/Geometric_distribution
//

A = 0.1;
R = distfun_grandgeom(400,800,A);
checkMeanVariance ( 400 , 800 , R , (1-A)/A , (1-A)/A^2 , rtol );

function p = mycdfgeom (X,A)
  p = 1 -(1-A)^(X+1)
endfunction
//
for A = linspace(0.1,0.9,10)
    R = distfun_grandgeom(1,N,A);
   checkPieceLaw1arg ( R , mycdfgeom , N , NC , A , rtol , atol );
end

// Check expansion of arguments
a = matrix(linspace(0.1,1,6),2,3);
checkExpansion1arg ( 2 , 3 , distfun_grandgeom , a);
